﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using データコンテナ;

namespace 妹デスクトップ
{
    public partial class 妹メイン : Form
    {
        public 妹メイン()
        {
            InitializeComponent();

        }
        //フォームとか
        private 会話ログ MessageLog ;
        private コミュニケーション欄 CommDialog;
        private 吹き出し ResponseDialog ;

        //フォーム移動関連
        private Point mouseDownPoint;
        private bool mouseIsDown=false;
        
        //共通コンテナ(全コントロールからアクセス可能)
        private 共通コンテナ DataConteiner = new 共通コンテナ();
        
        //通信スレ
        private Thread ThCommn;
        private 命令送受信 CommandWait = new 命令送受信();

        //妹スレ
        private Thread ThLittleSister;
        private 妹思考 AIroot = new 妹思考();

        private void 妹メイン_Load(object sender, EventArgs e)
        {
            CommDialog = new コミュニケーション欄();
            MessageLog = new 会話ログ();
            ResponseDialog = new 吹き出し();

            this.MessageLog.Show();
            this.CommDialog.Show();
            this.ResponseDialog.Show();
            
            initset();
            initlocationset();
        }
        #region 初期設定周り
        //初期設定
        private void initset()
        {
            eventset();
            
            ThCommn =new Thread(new ThreadStart(CommandWait.MessageLoop));

            ThLittleSister = new Thread(new ThreadStart(AIroot.ThinkMainLoop));

            this.MessageLog.setWatchLogBoard(this.DataConteiner.tmpMessags);
            this.AIroot.setThinkBoard(this.DataConteiner.tmpIMOUTMessage);

            ThCommn.Start();
            ThLittleSister.Start();
        }

        //初期位置設定
        private void initlocationset()
        {
            Rectangle rect=Screen.PrimaryScreen.Bounds;
            this.Location = new Point(rect.Right - (this.Width + 100), rect.Bottom - (this.Height + 40));

            Point pos = new Point(this.Left, this.Top);
            pos.X = pos.X - (this.ResponseDialog.Width + 40);
            pos.Y = pos.Y - 40;
            this.ResponseDialog.Location = pos;

            this.CommDialog.Location=new Point(this.Left-(this.CommDialog.Width+50),this.Height);
            
            pos = this.CommDialog.Location;
            pos.Y = pos.Y - (this.MessageLog.Height + 40);
            this.MessageLog.Location = pos;

        }
        //イベント設定
        private void eventset()
        {
            this.CommDialog.MessageSend += new EventHandler(CommDialog_MessageSend);
            this.CommandWait.GetMessage += new EventHandler(CommandWait_GetMessage);
            this.AIroot.ResponseMessage += new EventHandler(AIroot_ResponseMessage);
        }
        #endregion
        //位置設定
        private void locationset()
        {
            Point pos = new Point(this.Left, this.Top);
            pos.X = pos.X - (this.ResponseDialog.Width + 40);
            pos.Y = pos.Y - 40;
            this.ResponseDialog.Location = pos;

            pos = new Point();
            pos = this.CommDialog.Location;
            pos.Y = pos.Y - (this.MessageLog.Height + 40);
            this.MessageLog.Location = pos;

        }

        //妹からの返答
        void AIroot_ResponseMessage(object sender, EventArgs e)
        {
            this.DataConteiner.tmpMessags.Add(sender);
            this.ResponseDialog.setMessage((string)sender);

            //通信可能状態ならリモート先に投げる
            if (this.CommandWait.isConnection == true)
            {
                this.CommandWait.SendResponse((string)sender);
            }

        }

        //通信部からメッセージが送られたら
        void CommandWait_GetMessage(object sender, EventArgs e)
        {
            this.DataConteiner.tmpMessags.Add(sender);
            this.DataConteiner.tmpIMOUTMessage.Add(sender);
        }

        //コミュニケーションダイアログからメッセージが送られたら
        void CommDialog_MessageSend(object sender, EventArgs e)
        {
            this.DataConteiner.tmpMessags.Add(sender);
            this.DataConteiner.tmpIMOUTMessage.Add(sender);
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        #region 背景透過処理
        private void 妹メイン_Paint(object sender, PaintEventArgs e)
        {
            this.Width = this.pictureBox1.Image.Width;
            this.Height = this.pictureBox1.Image.Height;
            Point p = new Point(0, 0);
            this.pictureBox1.Location= p;
            

            Bitmap bmp;
            bmp = (Bitmap)this.pictureBox1.Image;
            this.TransparencyKey = bmp.GetPixel(0, 0);
        }
        #endregion

        #region フォーム移動
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                mouseDownPoint = new Point(e.X, e.Y);
                mouseIsDown = true;
            }

        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseIsDown && e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                this.Left += e.X - mouseDownPoint.X;
                this.Top += e.Y - mouseDownPoint.Y;
            }

        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                mouseIsDown = false;
            }

        }
        #endregion

        private void 妹メイン_Move(object sender, EventArgs e)
        {
            if (ResponseDialog == null) return;
            this.locationset();
        }

        private void 終了ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ThLittleSister.Abort();
            ThCommn.Abort();
            Application.Exit();
        }
    }
}